﻿#region Copyright Syncfusion Inc. 2001 - 2010
// Copyright Syncfusion Inc. 2001 - 2010. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Tools.Controls;
using Syncfusion.Windows.Shared;

namespace WizardSample
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : ChromelessWindow
    {

        #region Constructor

        /// <summary>
        /// Initializes a new instance of the <see cref="Window1"/> class.
        /// </summary>
        public Window1()
        {
            InitializeComponent();
            List<string> mypages = new List<string>();
            mypages.Add("Welcome");
            mypages.Add("License Agreement");
            mypages.Add("Profile");
            mypages.Add("Skin");
            mypages.Add("Features");
            mypages.Add("Install");
            mypages.Add("Thank you");
            wizardControl.Pages = mypages;
        }

        #endregion
    }
    public class MyWizard : WizardControl
    {
        ListView list;

        public MyWizard()
        {
            DefaultStyleKey = typeof(MyWizard);
            SelectedPageChanged += MyWizard_SelectedPageChanged;
            Loaded += MyWizard_Loaded;
        }
                  
        public List<string> Pages
        {
            get { return (List<string>)GetValue(PagesProperty); }
            set { SetValue(PagesProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Pages.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty PagesProperty =
            DependencyProperty.Register("Pages", typeof(List<string>), typeof(MyWizard), new PropertyMetadata(null));

        public override void OnApplyTemplate()
        {
            list = GetTemplateChild("PART_ListView") as ListView;
            if(list!=null)
                list.SelectionChanged += list_SelectionChanged;
            base.OnApplyTemplate();
        }

        void MyWizard_Loaded(object sender, RoutedEventArgs e)
        {
            SelectItemInList();
        }

        void list_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            SelectPage(); 
        }

        void MyWizard_SelectedPageChanged(object sender, RoutedEventArgs e)
        {
            SelectItemInList();
        }

        void SelectItemInList()
        {
            if (list != null)
            {
                int index = Items.IndexOf(SelectedWizardPage); // Get the index using ItemContainerGenerator while using ItemsSource
                if (index >= 0 && list.SelectedIndex != index)
                    list.SelectedIndex = index;
            }
        }

        void SelectPage()
        {
            if (list != null)
            {
                int index = list.SelectedIndex;
                if (index >= 0 && index != Items.IndexOf(SelectedWizardPage)) // Get the index using ItemContainerGenerator while using ItemsSource
                    SelectedWizardPage = Items[index] as WizardPage; // Get the item using ItemContainerGenerator while using ItemsSource       
            }
        }
    }
}

